
//			ForceFGWin.cpp


#ifndef FORCEFGWIN_CPP
#define FORCEFGWIN_CPP				1.0.0.0



int ForceForegroundWindow( HWND WindowHandle )
{
	//		http://www.tek-tips.com/faqs.cfm?fid=4262
	//		http://www.codeproject.com/Tips/76427/How-to-bring-window-to-top-with-SetForegroundWindo

	if ( !WindowHandle )
		return -1;

	DWORD ForegroundThread			= GetWindowThreadProcessId( GetForegroundWindow(), NULL );
	DWORD AppThread					= GetCurrentThreadId();
	UINT ShowMode					= SW_RESTORE;
	DWORD ForegroundLockTimeoutSave	= 0;

	ANIMATIONINFO SaveAnimationInfo;
	ANIMATIONINFO DisableAnimations;
	BOOL GotAnimationInfo			= FALSE;


	SaveAnimationInfo.cbSize = sizeof( ANIMATIONINFO );
	DisableAnimations.cbSize = sizeof( ANIMATIONINFO );
	DisableAnimations.iMinAnimate = 0;

	GotAnimationInfo = SystemParametersInfo( SPI_GETANIMATION, sizeof( ANIMATIONINFO ), &SaveAnimationInfo, 0 );
	SystemParametersInfo( SPI_SETANIMATION, sizeof( ANIMATIONINFO ), &DisableAnimations, 0 );
	SystemParametersInfo( SPI_GETFOREGROUNDLOCKTIMEOUT, 0, &ForegroundLockTimeoutSave, 0 );


	if ( IsZoomed( WindowHandle ) )
		ShowMode = SW_MAXIMIZE;

	if ( ForegroundThread != AppThread ) {
		AttachThreadInput( ForegroundThread, AppThread, TRUE );
		SystemParametersInfo( SPI_SETFOREGROUNDLOCKTIMEOUT, 0, 0, SPIF_SENDCHANGE );
		AllowSetForegroundWindow( GetCurrentProcessId() );
		BringWindowToTop( WindowHandle );
		ShowWindow( WindowHandle, ShowMode );
		SetForegroundWindow( WindowHandle );
		SystemParametersInfo( SPI_SETFOREGROUNDLOCKTIMEOUT, 0, (void*) ForegroundLockTimeoutSave, SPIF_SENDCHANGE );
		AttachThreadInput( ForegroundThread, AppThread, FALSE );
	}
	else {
		BringWindowToTop( WindowHandle );
		ShowWindow( WindowHandle, ShowMode );
		SetForegroundWindow( WindowHandle );
	}

	if ( GotAnimationInfo )
		SystemParametersInfo( SPI_SETANIMATION, sizeof( ANIMATIONINFO ), &SaveAnimationInfo, 0 );

	return 0;
}


#endif	//	FORCEFGWIN_CPP


/*

	1.0.0.0		2024-03-13

*/

